'''

   Configuration

'''

# =============================================================================
# >> IMPORTS
# =============================================================================
# EventScripts Imports
import es
import cfglib

# GunGame Imports
from gungame51.core.cfg import generate_header

# =============================================================================
# >> GLOBAL VARIABLES
# =============================================================================
config_gg = cfglib.AddonCFG('%s/cfg/' % es.ServerVar('eventscripts_gamedir') +
    'gungame51/custom_addon_configs/monday_knife.cfg') 

config = cfglib.AddonCFG('%s/cfg/' % es.ServerVar('eventscripts_gamedir') +
    'monday_knife.cfg')
    
# =============================================================================
# >> LOAD & UNLOAD
# =============================================================================
def load():
    '''
        Code for redirection of config file (because idiots can't find it.)    
    '''
    ###########################################################################
    generate_header(config_gg)
    config_gg.text('')
    config_gg.text('DO NOT CHANGE ANYTHING IN THIS FILE!!')
    config_gg.text('THE CONFIG FILE FOR THIS MOD IS LOCATED AT: ' +
                    '/CFG/MONDAY_KNIFE.CFG')
    config_gg.text('')
    config_gg.text('exec monday_knife', False)
    config_gg.write()        
    ###########################################################################
    
    generate_header(config)

    # Divider (Basic)
    config.text('')
    config.text('#'*76)  
    config.text('// >> BASIC SETTINGS')  
    config.text('#'*76)  
    
    # Monday Knife
    config.text('')
    config.text('=' * 76)
    config.text('>> MONDAY\'S KNIFE MOD')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Turns on the final knife fight.')
    config.text('Note:')
    config.text('   * This version requires GunGame 5.1 ' +
                '(http://www.gungame5.com).')
    config.text('Options:')
    config.text('   0 = (Disabled) Do not load monday_knife.')
    config.text('   1 = (Enabled) Load monday_knife.')
    config.text('Default Value: 1')
    config.cvar('monday_knife', 1, 'On/Off').addFlag('notify')

    # Time limit
    config.text('')
    config.text('=' * 76)
    config.text('>> TIME LIMIT')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Maximum amount of seconds a fight can go on.')
    config.text('Note:')
    config.text('   * The person with the lowest health will be slayed, and' +
                    ' punished.')        
    config.text('Options:')
    config.text('   0 = (Disabled) No limit.')
    config.text('   # = (Enabled) Number of seconds.')
    config.text('Default Value: 25')
    config.cvar('monday_knife_time', 25, 'Time Limit').addFlag('notify')  

    # Beacon
    config.text('')
    config.text('=' * 76)
    config.text('>> BEACON')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Enable/Disable Beacons')        
    config.text('Options:')
    config.text('   0 = (Disabled) No Beacons.')
    config.text('   1 = (Enabled) Use Beacons.')
    config.text('Default Value: 1')
    config.cvar('monday_knife_beacon', 1, 'Beacons').addFlag('notify')   

    # Teleport
    config.text('')
    config.text('=' * 76)
    config.text('>> TELEPORTING')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Enable/Disable Teleporting')        
    config.text('Note:')
    config.text('   * Smart teleporting trys to help prevent abuse and bugs.')  
    config.text('Options:')
    config.text('   0 = (Disabled) Do not teleport.')
    config.text('   1 = (Enabled) Smart teleporting.')
    config.text('   2 = (Enabled) Normal teleporting.')
    config.text('Default Value: 1')
    config.cvar('monday_knife_teleport', 1, 'Teleporting').addFlag('notify')  

    # Force
    config.text('')
    config.text('=' * 76)
    config.text('>> FORCE FIGHT')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   When enabled the last 2 players alive will be forced to ' +
                'knife fight.')         
    config.text('Options:')
    config.text('   0 = (Disabled) Do not force the fight.')
    config.text('   1 = (Enabled) Force the fight.')
    config.text('Default Value: 0')
    config.cvar('monday_knife_force', 0, 'Force Fights').addFlag('notify') 

    # Bots
    config.text('')
    config.text('=' * 76)
    config.text('>> ALLOW BOTS')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Allow humans to fight bots.')         
    config.text('Options:')
    config.text('   0 = (Disabled) No Bots.')
    config.text('   1 = (Enabled) Allow Bots.')
    config.text('Default Value: 0')
    config.cvar('monday_knife_bots', 0, 'Allow Bots').addFlag('notify') 

    # Punishment Level
    config.text('')
    config.text('=' * 76)
    config.text('>> PUNISHMENT LEVEL')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Levels to take away from a player for a suicide.')        
    config.text('Note:')
    config.text('   * This will remove additional levels if gg_suicide_punis' + 
                'h is enabled.') 
    config.text('   * Prevents players from killing themselves to avoid ' + 
                'defeat.')  
    config.text('Options:')
    config.text('   0 = (Disabled) Do not remove any levels.')
    config.text('   # = (Enabled) Number of levels to remove.')
    config.text('Default Value: 0')
    config.cvar('monday_knife_punish_lvl', 0, 'GG Level Pun' + 
                                                   'ishment').addFlag('notify')     
    
    # Punishment Speed
    config.text('')
    config.text('=' * 76)
    config.text('>> PUNISHMENT SPEED')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Slows players by 15% if they commit suicide during a' + 
                'knife fight.')         
    config.text('Options:')
    config.text('   0 = (Disabled) Do not slow players.')
    config.text('   1 = (Enabled) Slow players as punishment.')
    config.text('Default Value: 0')
    config.cvar('monday_knife_punish_speed', 0, 'Speed Punish' + 
                                                      'ment').addFlag('notify') 

    # Bonus
    config.text('')
    config.text('=' * 76)
    config.text('>> WINNER SPEED BONUS')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Increase winner\'s speed by 10% next round only.')         
    config.text('Options:')
    config.text('   0 = (Disabled) Do not give speed bonus.')
    config.text('   1 = (Enabled) Give speed bonus.')
    config.text('Default Value: 0')
    config.cvar('monday_knife_bonus', 0, 'Speed Bonus').addFlag('notify') 

    # Divider (Disco)
    config.text('')
    config.text('#'*76) 
    config.text('// >> DISCO BALL SETTINGS')  
    config.text('#'*76) 

    # Disco Ball
    config.text('')
    config.text('=' * 76)
    config.text('>> DISCO BALL')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Adds a disco ball with lasers to make things more fun.')
    config.text('Note:')
    config.text('   * The person with the lowest health will be slayed')       
    config.text('Options:')
    config.text('   0 = (Disabled) Disable the disco ball')
    config.text('   1 = (Enabled) Use the disco ball.')
    config.text('Default Value: 1')
    config.cvar('monday_knife_disco', 1, 'Disco Mode').addFlag('notify')  

    config.text('')
    config.text('=' * 76)
    config.text('>> LASER POWER LEVEL')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Power level of the laser generator, this setting will')
    config.text('   increase/decrease the amount of lasers produced by the ' +
                    'disco ball.')
    config.text('Note:')
    config.text('   * This may cause lag or low fps if too high.')       
    config.text('   * Power range is 1 to 20') 
    config.text('Options:')
    config.text('   # = Laser intensity.')
    config.text('Default Value: 5')
    config.cvar('monday_knife_laser', 5, 'Laser Power LVL').addFlag('notify')  

    config.text('')
    config.text('=' * 76)
    config.text('>> COLOR POWER LEVEL')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Power level of the color generator, this setting will')
    config.text('   increase/decrease the amount of colors produced by the ' +
                    'lasers.')
    config.text('   Level 1 yields 7 basic colors, where Level 5 will ' + 
                    'yield 206!')
    config.text('Note:')     
    config.text('   * Power range is 1 to 5') 
    config.text('Options:')
    config.text('   # = Laser intensity.')
    config.text('Default Value: 5')
    config.cvar('monday_knife_color', 5, 'Color Power LVL').addFlag('notify')  

    # Divider (Sound)
    config.text('')
    config.text('#'*76)  
    config.text('// >> MUSIC/SOUND SETTINGS')  
    config.text('#'*76) 

    # Chicken
    config.text('')
    config.text('=' * 76)
    config.text('>> CHICKEN SOUND')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Sound to play when a player chickens out.')         
    config.text('Options:')
    config.text('   0 = (Disabled) Do not play a sound.')
    config.text('   "file.mp3" = (Enabled) Name of sound file.')
    config.text('Default Value: chicken.wav')
    config.cvar('monday_knife_chicken', 'chicken.wav', 'Chicken ' + 
                                                     'Sound').addFlag('notify')   

    # Random
    config.text('')
    config.text('=' * 76)
    config.text('>> MUSIC SHUFFLE')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Randomize the sound files every map change. Otherwise, ')
    config.text('   the songs will go through a rotation.')
    config.text('Note:')
    config.text('   * The same file will not play twice in a row unless no ' +
                      'other song')
    config.text('     is available.')                    
    config.text('Options:')
    config.text('   0 = (Disabled) Do not use shuffle.')
    config.text('   1 = (Enabled) Shuffle music.')
    config.text('Default Value: 0')
    config.cvar('monday_knife_shuffle', 0, 'Shuffle').addFlag('notify')   
    
    # Sound list type
    config.text('')
    config.text('=' * 76)
    config.text('>> MUSIC LIST TYPE')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Determines which sound files are played.')
    config.text('Note:')
    config.text('   * Only .mp3 and .wav files will be automatically added.')
    config.text('   * It is good practice to leave out spaces in file names.')        
    config.text('Options:')
    config.text('   0 = (Automatic) Use all the music in the directory.')
    config.text('   1 = (Manual) Use the next setting to specify a list.')
    config.text('Default Value: 0')
    config.cvar('monday_knife_type', 0, 'Music List Type').addFlag('notify')   

    # Sound list
    config.text('')
    config.text('=' * 76)
    config.text('>> CUSTOM MUSIC LIST')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Comma seperated list of music files in your directory.')              
    config.text('Note:')
    config.text('   * This setting is only if monday_knife_type is set to 1.' + 
                ' (Custom)')
    config.text('   * It is good practice to leave out spaces in file names.')           
    config.text('Example:')
    config.text('   mysong.mp3,monday_song.mp3,ilovemonday.mp3')
    config.text('Default Value: "none"')
    config.cvar('monday_knife_list', "none", 'Custom List').addFlag('notify') 

    # Max sounds per map
    config.text('')
    config.text('=' * 76)
    config.text('>> MAX SOUND FILES PER MAP')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Maximum amount of music/sound files a player will downl' +
                'oad (per map).')
    config.text('Note:')
    config.text('   * HIGHLY recommended if you are using automatic listing.')        
    config.text('Options:')
    config.text('   0 = (Disabled) No limit.')
    config.text('   # = (Enabled) Number of sounds to use each map.')
    config.text('Default Value: 5')
    config.cvar('monday_knife_limit', 5, 'Music Limit').addFlag('notify')   

    # Sound Dir
    config.text('')
    config.text('=' * 76)
    config.text('>> MUSIC/SOUND DIRECTORY')
    config.text('=' * 76)
    config.text('Description:')
    config.text('   Directory where sound files are located.')
    config.text('Note:')
    config.text('   * Do not include /cstrike/sound')
    config.text('   * This cannot be blank!')
    config.text('   * You must know what you are doing if you change this!')    
    config.text('   * Leave off leading and trailing "/"s and "\\"s') 
    config.text('Default Value: monday_knife')
    config.cvar('monday_knife_dir', 'monday_knife', 'Directo' + 
                                                        'ry').addFlag('notify')  

    config.write()
    es.dbgmsg(0, '\tmonday_knife.cfg')


def unload():
    global config

    # Remove the "notify" flags as set by addFlag('notify')
    for cvar in config.getCvars().keys():
        es.flags('remove', 'notify', cvar)

    # Delete the cfglib.AddonCFG instance
    del config